
Summary:        Atomic Secured Linux plesk nginx module
Name:           atomic-accelerator
Version:        0.1
Release:        4.art
URL:            http://www.atomicorp.com/
Packager:	Scott R. Shinn <scott@atomicrocketturtle.com>
Vendor:		Atomic Corporate Industries
Source0:        domain.sh
Source1:	subdomain.sh
Source2:	mod_rpaf.conf
Source3: 	vhost.template
Source4:	proxy.default
Source5:	nginx.conf
Source6:	subdomain.template
License:        Commercial
Group:          System/Servers
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root
BuildArch:      noarch
Requires:       psa >= 9.3
Requires:	nginx mod_rpaf



%description
Atomic Accelerator is an apache acceleration module for
Plesk.


%prep
	

%build

%install
%{__rm} -rf %{buildroot}
%{__mkdir_p} %{buildroot}/etc/nginx/
%{__mkdir_p} %{buildroot}/usr/share/atomic-accelerator
%{__mkdir_p} %{buildroot}/usr/local/psa/admin/bin/

%{__install} -m 0700 %{SOURCE0} %{buildroot}/usr/local/psa/admin/bin/
%{__install} -m 0700 %{SOURCE1} %{buildroot}/usr/local/psa/admin/bin/
%{__install} -m 0644 %{SOURCE2} %{buildroot}/usr/share/atomic-accelerator/
%{__install} -m 0644 %{SOURCE3} %{buildroot}/etc/nginx/
%{__install} -m 0644 %{SOURCE4} %{buildroot}/etc/nginx/
%{__install} -m 0644 %{SOURCE5} %{buildroot}/usr/share/atomic-accelerator/
%{__install} -m 0644 %{SOURCE6} %{buildroot}/etc/nginx/


%clean
%{__rm} -rf %{buildroot}


#%triggerin -- sb-publish
# http://download1.parallels.com/Plesk/PPP9/Doc/en-US/plesk-9.3-unix-advanced-administration-guide/index.htm?fileName=64599.htm
#if [ $1 = 1 ]; then
#  /opt/sitebuilder/utils/configure --httpd_port 8080
#fi


%post 
# Install only macro
if [ $1 = 1 ]; then

  # debug
  /usr/bin/killall -9 httpd 

  # set port
  /usr/local/psa/admin/sbin/websrvmng --set-http-port --port=8080 
  /usr/local/psa/admin/sbin/websrvmng --reconfigure-all 

  # Add handlers to DB
  MYSQL="mysql -u admin -p`cat /etc/psa/.psa.shadow` psa "
  echo "insert into event_handlers (action_id, priority, user, command) values ('46', '100', 'root', '/usr/local/psa/admin/bin/domain.sh');" | $MYSQL
  echo "insert into event_handlers (action_id, priority, user, command) values ('39', '100', 'root', '/usr/local/psa/admin/bin/subdomain.sh');" | $MYSQL

  # Copy over new rpaf config
  cp -f /usr/share/atomic-accelerator/mod_rpaf.conf /etc/httpd/conf.d/mod_rpaf.conf

  # Set IP in rpaf config
  for i in `/sbin/ip addr | grep -v 'inet6' | grep -v '127\.[0-9]*\.[0-9]*\.[0-9]*' | sed -n -e 's/^ *inet \([0-9\.]*\).*$/\1/ p'`; do
    /usr/bin/perl -p -i -e "s[127.0.0.1][$i 127.0.0.1]g" /etc/httpd/conf.d/mod_rpaf.conf
  done

  # Copy over new /etc/nginx/nginx.conf
  cp -f /usr/share/atomic-accelerator/nginx.conf /etc/nginx/nginx.conf


  # Horde
  if [ -f /usr/share/psa-horde/index.php ]; then
    /usr/local/psa/admin/sbin/webmailmng --disable --name=horde
    /usr/local/psa/admin/sbin/webmailmng --enable --name=horde
  fi

  # Atmail
  if [ -f /var/www/atmail/index.php ]; then
    /usr/local/psa/admin/sbin/webmailmng --disable --name=atmail >/dev/null 2>&1
    /usr/local/psa/admin/sbin/webmailmng --enable --name=atmail >/dev/null 2>&1
    /usr/local/psa/admin/sbin/webmailmng --disable --name=atmailcom >/dev/null 2>&1
    /usr/local/psa/admin/sbin/webmailmng --enable --name=atmailcom >/dev/null 2>&1
  fi


  # If this is the first time, create all the domains configs
  for domain in `awk -F\/ '/^Include/ {print $5}' /etc/httpd/conf.d/zz010_psa_httpd.conf`; do
    export NEW_DOMAIN_NAME=$domain
    /usr/local/psa/admin/bin/domain.sh
    # subdomains
    for subdomain in `awk '/ServerAlias/ {print $2}' /var/www/vhosts/$domain/conf/httpd.include`; do
      export NEW_SUBDOMAIN_NAME=$subdomain
      /usr/local/psa/admin/bin/domain.sh
    done
  done

  # Add nginx to startup
  /sbin/chkconfig nginx on
  /sbin/service nginx start
 
fi

%postun
if [ $1 = 0 ]; then
  # Stop and disable nginx
  if [ -f /etc/init.d/nginx ]; then
    /sbin/chkconfig nginx off >/dev/null 2>&1
    /sbin/service nginx stop >/dev/null 2>&1
  fi

  # TODO, delete actions from db
  MYSQL="mysql -u admin -p`cat /etc/psa/.psa.shadow` psa "
  echo "delete from event_handlers where command = '/usr/local/psa/admin/bin/domain.sh'" | $MYSQL
  echo "delete from event_handlers where command = '/usr/local/psa/admin/bin/subdomain.sh'" | $MYSQL
  # TODO, restore settings to original ports
  /usr/local/psa/admin/sbin/websrvmng --set-http-port --port=80 >/dev/null 2>&1
  /usr/local/psa/admin/sbin/websrvmng --reconfigure-all >/dev/null 2>&1

  # Horde
  if [ -f /usr/share/psa-horde/index.php ]; then
    /usr/local/psa/admin/sbin/webmailmng --disable --name=horde
    /usr/local/psa/admin/sbin/webmailmng --enable --name=horde
  fi

  # Atmail
  if [ -f /var/www/atmail/index.php ]; then
    /usr/local/psa/admin/sbin/webmailmng --disable --name=atmail >/dev/null 2>&1
    /usr/local/psa/admin/sbin/webmailmng --enable --name=atmail >/dev/null 2>&1
    /usr/local/psa/admin/sbin/webmailmng --disable --name=atmailcom >/dev/null 2>&1
    /usr/local/psa/admin/sbin/webmailmng --enable --name=atmailcom >/dev/null 2>&1
  fi



fi



%files
%defattr(-,root,root)
/etc/nginx/
/usr/share/atomic-accelerator/
/usr/local/psa/admin/bin/domain.sh
/usr/local/psa/admin/bin/subdomain.sh


%changelog
* Mon May 11 2010 Support <support@atomicorp.com> - 0.1-3
- Added @fallback to vhost.template
- Bugfix #XXX, for %post subdomain event creation to invoke the domain.sh script instead of the subdomain script.

* Wed Mar 17 2010 Support <support@atomicorp.com> - 0.1
- 
